﻿/*
	Clase:						objeto3d
	Descripción:				Interfaz para con el usuario al realizar operaciones de dibujo 3D
	Autor:						Gerson Montenegro
	E-mail:						gersonmontenegro@gmail.com
	Fecha última modificación:	18.05.2k5
	Licencia:					GNU/GPL
*/
import clases.operaciones;
import clases.dibujar;
class clases.objeto3d{
	var rotando_bln:Boolean = new Boolean();
	var vista_num:Number = new Number();
	var clickeado:Boolean = new Boolean();
	var presionado:Boolean = new Boolean();
	var rotarPrototipo:Object = new Object();
	var miNombre_str:String = new String();
	
	function objeto3d(nombreObjeto_str:String, posX:Number, posY:Number, rotX:Number, rotY:Number, rotZ:Number, color:String, lineas:Number, cache:Number){//, verificar_bln:Boolean
		var archivo_lv:LoadVars = new LoadVars();
		miNombre_str = nombreObjeto_str;
		//convirtiendo los grados que se envían a radianes que son los usados para los cálculos
		rotX *= Math.PI / 180;
		rotY *= Math.PI / 180;
		rotZ *= Math.PI / 180;
		cargarXml(nombreObjeto_str, posX, posY, rotX, rotY, rotZ, color, lineas, cache);
	}
	/*
		Nombre:			asignarEvento
		Parámetros:
						nombreEvento:	nombre del evento que se va asignar
						funcion:		función que se asignará
		Devuelve:		nada
		Descripción:	asignarEvento asigna una función enviada como 2 parámetro a la instancia que tiene como nombre el 1 parámetro
	*/
	function asignarEvento(nombreEvento:String, funcion:Function){
		_root[miNombre_str][nombreEvento] = funcion;
	}
	
	/*
		Nombre:			posicion
		Parámetros:
						Ninguno
		Devuelve:		Coordenas x,y de la posición en pantalla de la instancia
		Descripción:	posición devuelve la posición de la instancia dentro de la pantalla
	*/
	function posicion():String{
		return _root[miNombre_str]._x + "," + _root[miNombre_str]._y;
	}
	
	/*
		Nombre:			inicial
		Parámetros
						eje_str:	Eje de coordenadas X,Y,Z
		Devuelve		Una posición base sobre el eje de coordenadas especificado
		Descripción		Devuelve una posición base. Es usada específicamente para el trabajo de movimiento de puertas o ventanas
	*/
	function inicial(eje_str:String){
		return _root[miNombre_str].p_array[0][eje_str];
	}
	
	/*
		Nombre:			mover
		Parámetros
						eje_str:	Eje de coordenadas espacial
						factor_num:	Factor de desplazamiento
		Devuelve		Nada
		Descripción		Mueve tantas unidades como factor_num especifique en el eje espacial definido por eje_str		
	*/
	function mover(eje_str:String, factor_num:Number){
		var ww;
		for(ww in _root[miNombre_str].p_array){
			_root[miNombre_str].p_array[ww][eje_str] = Number(_root[miNombre_str].p_array[ww][eje_str]) + Number(factor_num);
		}
		_root[miNombre_str].dibujado_bln = false;
	}
	
	/*
		Nombre:			rotar
		Parámetros
						eje_str:	Eje de coordenadas espacial
						factor_num:	Factor de rotación
		Devuelve		Nada
		Descripción		Rota tantos grados como factor_num especifique en el eje espacial definido por eje_str		
	*/
	function rotar(eje_str:String, factor_num:Number){
		_root[miNombre_str].rotarPrototipo[eje_str] = Number(_root[miNombre_str].rotarPrototipo[eje_str]) + (factor_num * Math.PI / 180);
		_root[miNombre_str].dibujado_bln = false;
	}
	
	/*
		Nombre:			cargarXML
		Parámetros
						archivo_str:	Nombre del archivo que se cargará
						posX:			Posición inicial dentro de la pantalla en X
						posY:			Posición inicial dentro de la pantalla en Y
						rotX:			Rotación incial en eje espacial X
						rotY:			Rotación incial en eje espacial Y
						rotZ:			Rotación incial en eje espacial Z
						color:			Color con que se pintará la superficie
						lineas:			Valor que indica si se pintarán las líneas del la superficie
						cache:			Valor que indica si se cargará el XML o se procesará con PHP
	*/
	function cargarXml(archivo_str:String, posX:Number, posY:Number, rotX:Number, rotY:Number, rotZ:Number, color:String, lineas:Number, cache:Number){
		var x;
		var puntos_xml:XML = new XML();
		var contador = new Number();
		puntos_xml.ignoreWhite = true;
		puntos_xml.onLoad = function(){
			var puntero_mc:MovieClip = new MovieClip();
			var vista_num = 300;
			var clickeado = false;
			var oBasicas:operaciones = new operaciones();
			
			if(this.loaded){
				var puntos_array:Array = new Array();
				var puntos_array_tmp = new Array();
				var enlaces_array:Array = new Array();
				var rotacionInicial_obj:Object = new Object();
				var color:String = new String();
				var lineas:Number = new Number();
				
				rotacionInicial_obj.x = this.firstChild.childNodes[4].firstChild.nodeValue.toString().split(",")[0];
				rotacionInicial_obj.y = this.firstChild.childNodes[4].firstChild.nodeValue.toString().split(",")[1];
				rotacionInicial_obj.z = this.firstChild.childNodes[4].firstChild.nodeValue.toString().split(",")[2];
				
				color = this.firstChild.childNodes[5].firstChild.nodeValue;
				lineas = this.firstChild.childNodes[6].firstChild.nodeValue;
				
				var posX_num:Number = new Number(this.firstChild.childNodes[3].firstChild.nodeValue.toString().split(",")[0]);
				var posY_num:Number = new Number(this.firstChild.childNodes[3].firstChild.nodeValue.toString().split(",")[1]);
				var nombreInstancia_str:String = new String(this.firstChild.childNodes[2].firstChild.nodeValue);
				puntero_mc = _root.createEmptyMovieClip(nombreInstancia_str, _root.getNextHighestDepth());
				puntero_mc._x = posX_num;
				puntero_mc._y = posY_num;
				puntero_mc.miColor = color;
				puntero_mc.miNombre_str = nombreInstancia_str;
				puntero_mc.pintarLineas = lineas;
				puntero_mc.presionado = false;
				
				//creando arreglo de puntos
				for(x = 0; x < this.firstChild.childNodes[0].childNodes.length; x ++){
					puntos_array.push(oBasicas.crearTerna(this.firstChild.firstChild.childNodes[x].attributes.x, this.firstChild.firstChild.childNodes[x].attributes.y, this.firstChild.firstChild.childNodes[x].attributes.z));
				}
				
				rotarPrototipo = oBasicas.crearTerna(rotacionInicial_obj.x, rotacionInicial_obj.y, rotacionInicial_obj.z);
				
				puntos_array.reverse();
				contador = 0;
				for(x = puntos_array.length - 1; x >= 0; x --){
					puntos_array_tmp[contador] = puntos_array[x];
					contador ++;
				}
				puntos_array = puntos_array_tmp;
				
				//creando arreglo de enlaces
				for(x = 0; x < this.firstChild.childNodes[1].childNodes.length; x ++){
					enlaces_array.push(this.firstChild.childNodes[1].childNodes[x].firstChild.nodeValue);
				}
				//terminada la carga de datos nos vamos con la sgte parte del proceso
				var dibujaObjeto:dibujar = new dibujar(puntos_array, enlaces_array, rotarPrototipo, puntero_mc);
			}else{
				trace("fracasamos cargando el archivo ?");
			}
		}
		if(cache == 0){
			//cargar el XML usando el archivo index.php para procesar un AC
			puntos_xml.load("index.php?nombre=" + archivo_str + "&posx=" + posX + "&posy=" + posY + "&rotx=" + rotX + "&roty=" + rotY + "&rotz=" + rotZ + "&color=" + color + "&lineas=" + lineas + "&nc=" + Math.random(0, 65000));
		}else{
			//cargando el XML directamente
			puntos_xml.load(archivo_str + ".xml");
		}
	}
}