﻿/*
	Clase:						operaciones
	Descripción:				Clase usadada por objeto3d para realizar los cálculos requeridos para realizar las transformaciones geométricas
	Autor:						Gerson Montenegro
	E-mail:						gersonmontenegro@gmail.com
	Fecha última modificación:	18.05.2k5
	Licencia:					GNU/GPL
*/
class clases.operaciones{
	var escala:Number = new Number();
	var vista_num:Number = new Number();
	
	function operaciones(){
		vista_num = 300;//define el punto de vista base espacial
	}
	
    function crearTerna(x, y, z){
        var punto = new Object ();
        punto.x = x;
        punto.y = y;
        punto.z = z;
        return punto;
    };
    
	function crearCoordenada(x, y){
        var punto = new Object ();
        punto.x = x;
        punto.y = y;
        return punto;
    };
	
    function crearProyeccionEnPantalla(puntos, rotaciones) {
        var vectorDePunto_array = new Array();
        var sx = Math.sin(rotaciones.x);
        var cx = Math.cos(rotaciones.x);
        var sy = Math.sin(rotaciones.y);
        var cy = Math.cos(rotaciones.y);
        var sz = Math.sin(rotaciones.z);
        var cz = Math.cos(rotaciones.z);
        var escala;
		var x, y, z, xy, xz, yx, yz, zx, zy, escala;
        var i = puntos.length;
        while (i--) {
            x = puntos[i].x;
            y = puntos[i].y;
            z = puntos[i].z;
            xy = (cx * y) - (sx * z);
            xz = (sx * y) + (cx * z);
            yz = (cy * xz) - (sy * x);
            yx = (sy * xz) + (cy * x);
            zx = (cz * yx) - (sz * xy);
            zy = (sz * yx) + (cz * xy);
            escala = vista_num / (vista_num + yz);
            x = zx * escala;
            y = zy * escala;
            vectorDePunto_array[i] = crearCoordenada(x, y);
        }
        return vectorDePunto_array;
    };
	
    function crearProyeccionEnPantallaTrasladado(puntos:Array, eje:String, factor:Number) {
        var vectorDePunto_array = new Array();
        var x, y, z, xy, xz, yx, yz, zx, zy, escala;
        var i = puntos.length;
        while (i--) {
            x = puntos[i].x;
            y = puntos[i].y;
            z = puntos[i].z;
			
			switch(eje){
				case "x":
						x += factor;
						break;
				case "y":
						y += factor;
						break;
				case "z":
						z += factor;
						break;
				default:
						break;
			}
			var sx = Math.sin(0);
			var cx = Math.cos(0);
			var sy = Math.sin(0);
			var cy = Math.cos(0);
			var sz = Math.sin(0);
			var cz = Math.cos(0);
            xy = (cx * y) - (sx * z);
            xz = (sx * y) + (cx * z);
            yz = (cy * xz) - (sy * x);
            yx = (sy * xz) + (cy * x);
            zx = (cz * yx) - (sz * xy);
            zy = (sz * yx) + (cz * xy);
            escala = vista_num / (vista_num + yz);
            x = zx * escala;
            y = zy * escala;
			
			trace(x + "," + y + "," + z + " : " + escala);
            vectorDePunto_array[i] = crearCoordenada(x, y);
        }
        return vectorDePunto_array;
    }
}